"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
exports.__esModule = true;
var commander_1 = __importDefault(require("commander"));
var nedb_1 = __importDefault(require("nedb"));
var tweet_1 = __importDefault(require("./commands/tweet"));
var timeline_1 = require("./commands/timeline");
var oauth_1 = require("./commands/oauth");
var path = __dirname + "/configs/database";
var main = function () { return __awaiter(void 0, void 0, void 0, function () {
    var db, userCheck, userId, NO_COMMAND_SPECIFIED;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4 /*yield*/, new nedb_1["default"]({
                    filename: path,
                    autoload: true
                })];
            case 1:
                db = _a.sent();
                return [4 /*yield*/, new Promise(function (resolve) {
                        db.findOne({ selected: true }, function (err, doc) {
                            if (!doc) {
                                resolve(false);
                            }
                            else {
                                resolve(true);
                            }
                        });
                    })];
            case 2:
                userCheck = _a.sent();
                if (!!userCheck) return [3 /*break*/, 4];
                return [4 /*yield*/, oauth_1.Login(db)];
            case 3:
                _a.sent();
                return [2 /*return*/];
            case 4:
                commander_1["default"]
                    .version('0.0.1', '-v, --version', 'バージョンを確認')
                    .option('-l, --login', 'ログイン')
                    .option('-lo, --logout', 'ログアウト')
                    .option('-t, --tweet [tweet]', 'ツイート')
                    .option('-tl, --timeline [user]', 'タイムラインを取得')
                    .option('-c, --console', 'testコマンド')
                    .parse(process.argv);
                if (commander_1["default"].login)
                    oauth_1.Login(db);
                if (commander_1["default"].logout)
                    oauth_1.Logout(db, path);
                if (commander_1["default"].tweet) {
                    if (typeof commander_1["default"].tweet === 'string') {
                        tweet_1["default"](db, commander_1["default"].tweet);
                        return [2 /*return*/];
                    }
                    tweet_1["default"](db, '');
                    return [2 /*return*/];
                }
                if (commander_1["default"].timeline) {
                    if (typeof commander_1["default"].timeline === 'string') {
                        if (commander_1["default"].timeline.charAt(0) === '@') {
                            userId = commander_1["default"].timeline.slice(1);
                            timeline_1.timeline(db, userId);
                            return [2 /*return*/];
                        }
                        timeline_1.timeline(db, commander_1["default"].timeline);
                        return [2 /*return*/];
                    }
                    timeline_1.timeline(db, '');
                    return [2 /*return*/];
                }
                if (commander_1["default"].console) {
                    console.log('機能のテスト');
                    db.find({ selected: true }, function (err, result) { return __awaiter(void 0, void 0, void 0, function () {
                        return __generator(this, function (_a) {
                            if (result.length) {
                                console.log("" + result.slice(-1)[0].name);
                            }
                            else {
                                console.log('ログインしていません');
                            }
                            return [2 /*return*/];
                        });
                    }); });
                }
                NO_COMMAND_SPECIFIED = process.argv.length <= 2;
                if (NO_COMMAND_SPECIFIED) {
                    db.find({ selected: true }, function (err, result) { return __awaiter(void 0, void 0, void 0, function () {
                        return __generator(this, function (_a) {
                            if (result.length) {
                                console.log(result.slice(-1)[0].name + " \u3067\u30ED\u30B0\u30A4\u30F3\u3057\u3066\u3044\u307E\u3059");
                            }
                            else {
                                console.log('ログインしていません');
                            }
                            return [2 /*return*/];
                        });
                    }); });
                }
                return [2 /*return*/];
        }
    });
}); };
exports["default"] = main;
