"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
exports.__esModule = true;
var axios_1 = __importDefault(require("axios"));
var prompts_1 = __importDefault(require("prompts"));
var configs_json_1 = require("../configs/configs.json");
var inputTweet = function () { return __awaiter(void 0, void 0, void 0, function () {
    var onCancel, input, err_1;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                _a.trys.push([0, 2, , 3]);
                onCancel = function () {
                    console.error('Error: 入力内容が確認できませんでした...もう一度最初から入力してください。');
                };
                return [4 /*yield*/, prompts_1["default"]([
                        {
                            type: 'text',
                            name: 'input',
                            message: 'ツイート: ',
                            validate: function (value) { return (!value ? '何か入力してください' : true); }
                        }
                    ], { onCancel: onCancel })];
            case 1:
                input = (_a.sent()).input;
                return [2 /*return*/, { input: input }];
            case 2:
                err_1 = _a.sent();
                throw new Error('入力内容が確認できませんでした...もう一度最初から入力してください。');
            case 3: return [2 /*return*/];
        }
    });
}); };
var postTweet = function (accessToken, accessTokenSecret, tweet) { return __awaiter(void 0, void 0, void 0, function () {
    var err_2;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                _a.trys.push([0, 2, , 3]);
                return [4 /*yield*/, axios_1["default"].post(configs_json_1.middlewareUrl + "/postTweet", {
                        access_token: accessToken,
                        access_token_secret: accessTokenSecret,
                        tweet: tweet
                    })];
            case 1:
                _a.sent();
                return [2 /*return*/, true];
            case 2:
                err_2 = _a.sent();
                throw new Error('Twitter APIに問題があるようです・・・時間を空けてからもう一度試してみてください。');
            case 3: return [2 /*return*/];
        }
    });
}); };
var checkUser = function (db) { return __awaiter(void 0, void 0, void 0, function () {
    var Token;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4 /*yield*/, new Promise(function (resolve) {
                    db.find({ selected: true }, function (err, result) { return __awaiter(void 0, void 0, void 0, function () {
                        var _a, accessToken, accessTokenSecret;
                        return __generator(this, function (_b) {
                            if (!err) {
                                _a = result.slice(-1)[0] // 変更
                                , accessToken = _a.accessToken, accessTokenSecret = _a.accessTokenSecret;
                                if (accessToken && accessTokenSecret) {
                                    resolve({ accessToken: accessToken, accessTokenSecret: accessTokenSecret });
                                }
                                return [2 /*return*/];
                            }
                            throw new Error('アカウントが見つからないようです...もう一度ログインを試してみてください');
                        });
                    }); });
                })];
            case 1:
                Token = _a.sent();
                return [2 /*return*/, Token];
        }
    });
}); };
var Tweet = function (db, tweet) { return __awaiter(void 0, void 0, void 0, function () {
    var _a, accessToken, accessTokenSecret, input, _b, accessToken, accessTokenSecret, err_3;
    return __generator(this, function (_c) {
        switch (_c.label) {
            case 0:
                _c.trys.push([0, 8, , 9]);
                if (!tweet) return [3 /*break*/, 3];
                return [4 /*yield*/, checkUser(db)];
            case 1:
                _a = _c.sent(), accessToken = _a.accessToken, accessTokenSecret = _a.accessTokenSecret;
                return [4 /*yield*/, postTweet(accessToken, accessTokenSecret, tweet)];
            case 2:
                if (_c.sent()) {
                    console.log("Success: \u9001\u4FE1\u5B8C\u4E86\n\u30C4\u30A4\u30FC\u30C8: " + tweet);
                    return [2 /*return*/];
                }
                throw new Error('ツイートの送信にエラーがあったようです...');
            case 3: return [4 /*yield*/, inputTweet()];
            case 4:
                input = (_c.sent()).input;
                if (!input) return [3 /*break*/, 7];
                return [4 /*yield*/, checkUser(db)];
            case 5:
                _b = _c.sent(), accessToken = _b.accessToken, accessTokenSecret = _b.accessTokenSecret;
                return [4 /*yield*/, postTweet(accessToken, accessTokenSecret, input)];
            case 6:
                if (_c.sent()) {
                    console.log("Success: \u9001\u4FE1\u5B8C\u4E86\n\u30C4\u30A4\u30FC\u30C8: " + input);
                    return [2 /*return*/];
                }
                throw new Error('ツイートの送信にエラーがあったようです...');
            case 7: return [3 /*break*/, 9];
            case 8:
                err_3 = _c.sent();
                console.error(err_3.message);
                return [3 /*break*/, 9];
            case 9: return [2 /*return*/];
        }
    });
}); };
exports["default"] = Tweet;
